;      ,
;  
;LoadFromZIP(FileName$,ZIPName$="",OriginalName=False)
;LoadMeshFromZIP%(FileName$,TextureName$="",ZIPFile$="")
;  
;FreeTempFiles()

;:
;Tex = LoadTexture(LoadFromZIP("texture.bmp","zipfile.zip")
;Sound = LoadSound(LoadFromZIP("mywav.wav")



Global ZLIB_LastZipFile$

Type ZLIB_TempZIPFile
 Field FileName$
End Type

Const UNZ_OK=0
Const UNZ_CRCERROR=-105

Function LoadFromZIP$(FileName$,ZIPFile$="",OriginalName=False)
 If ZIPFile$="" Then ZIPFile$ = ZLIB_LastZipFile$
 If Not FileSize(ZIPFile$) Then
   RuntimeError ("ZIP File Not Found (" + ZIPFile$ + ")")
 End If
 If OriginalName Then
   TempFile$ = SystemProperty ("tempdir")+FileName$
 Else
   TempFile$ = Str Int Rnd(11111,99999)
   TempFile$ = SystemProperty ("tempdir")+"~UZ"+TempFile$+".tmp"
 EndIf
 ZLIB_Unzip(ZIPFile$,FileName$,TempFile$)
 TempFiles.ZLIB_TempZIPFile = New ZLIB_TempZIPFile
 TempFiles\FileName$ = TempFile$
 ZLIB_LastZipFile$ = ZIPFile$
 Return TempFile$
End Function

Function LoadMeshFromZIP%(FileName$,TextureName$="",ZIPFile$="")
 If TextureName$<>"" Then LoadFromZIP$(TextureName$,ZIPFile$,True)
 TempMesh = LoadMesh(LoadFromZIP$(FileName$,ZIPFile$,True))
 Return TempMesh
End Function

Function FreeTempFiles()
 For TempFiles.ZLIB_TempZIPFile = Each ZLIB_TempZIPFile
 DeleteFile TempFiles\FileName$
 Delete TempFiles
 Next
End Function

; ****************************************************
; * ZLIB_Unzip(ZIPFileName$,FileName$,DestFileName$)
; ****************************************************

Function ZLIB_Unzip(ZIPFileName$,FileName$,DestFileName$)

 Success = False
 ZLIB_Handle=ZLIB_unzOpen(ZIPFileName$)

 If ZLIB_Handle <> UNZ_OK Then

   If ZLIB_unzLocateFile(ZLIB_Handle,FileName$,2) = UNZ_OK Then
     ZLIB_InfoBank=CreateBank(20*4)
   ZLIB_FileBuffer=CreateBank(260)
   ZLIB_Return = ZLIB_unzGetCurrentFileInfo(ZLIB_Handle,ZLIB_InfoBank,ZLIB_FileBuffer,BankSize(ZLIB_FileBuffer),0,0,0,0)

   If ZLIB_Return = UNZ_OK Then
   FreeBank ZLIB_FileBuffer
   ZLIB_Return = ZLIB_unzOpenCurrentFile(ZLIB_Handle)
   If ZLIB_Return = UNZ_OK Then
   DeCompressedSize=PeekInt(ZLIB_InfoBank,28)
   FreeBank ZLIB_InfoBank
   DeCompressBank=CreateBank(DeCompressedSize)
   ZLIB_Return = ZLIB_unzReadCurrentFile(ZLIB_Handle,DeCompressBank,BankSize(DeCompressBank))
   If ZLIB_Return = DeCompressedSize Then
   FileBank=WriteFile(DestFileName$)
   WriteBytes DeCompressBank,FileBank,0,BankSize(DeCompressBank)
   CloseFile FileBank
   Else
   RuntimeError ("Read error in " + ZIPFileName$);
   EndIf
     ZLIB_Return = ZLIB_unzCloseCurrentFile(ZLIB_Handle)
    If ZLIB_Return = UNZ_CRCERROR Then
           RuntimeError ("CRC error in " + ZIPFileName$);
     Else
     Success = True
     EndIf
     Else
         RuntimeError ("Error in " + ZIPFileName$)
     EndIf
   Else
       RuntimeError ("Error in " + ZIPFileName$)
   EndIf
   Else
     RuntimeError (FileName$ + " not found in " + ZIPFileName$)
   End If
  Else
   RuntimeError (ZIPFileName$ + " not found")
 EndIf

 ZLIB_Close = ZLIB_unzClose(ZLIB_Handle)
 If ZLIB_Close <> UNZ_OK Then
   RuntimeError (ZIPFileName$ + " not closed")
 EndIf

 Return Success

End Function